// OptiX_Test.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

/*
* Copyright (c) 2008 - 2009 NVIDIA Corporation.  All rights reserved.
*
* NVIDIA Corporation and its licensors retain all intellectual property and proprietary
* rights in and to this software, related documentation and any modifications thereto.
* Any use, reproduction, disclosure or distribution of this software and related
* documentation without an express license agreement from NVIDIA Corporation is strictly
* prohibited.
*
* TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THIS SOFTWARE IS PROVIDED *AS IS*
* AND NVIDIA AND ITS SUPPLIERS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED,
* INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
* PARTICULAR PURPOSE.  IN NO EVENT SHALL NVIDIA OR ITS SUPPLIERS BE LIABLE FOR ANY
* SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES WHATSOEVER (INCLUDING, WITHOUT
* LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS, BUSINESS INTERRUPTION, LOSS OF
* BUSINESS INFORMATION, OR ANY OTHER PECUNIARY LOSS) ARISING OUT OF THE USE OF OR
* INABILITY TO USE THIS SOFTWARE, EVEN IF NVIDIA HAS BEEN ADVISED OF THE POSSIBILITY OF
* SUCH DAMAGES
*/

#include <optix.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sutil.h>

#include "Tutorial.h"

using namespace optix;

int _tmain(int argc, _TCHAR* argv[])
{
	GLUTDisplay::init( argc, argv );

	unsigned int width = 1080u, height = 720u;
	char current[MAX_PATH];

	::GetCurrentDirectory(MAX_PATH, current);
	std::string texture_path(current);
	texture_path.append("/data");

	std::stringstream title;
	title << "Tutorial 0";
	try 
	{
		Tutorial tutorial(texture_path);
		tutorial.setDimensions( width, height );
		GLUTDisplay::run( title.str(), &tutorial );
	}
	catch( Exception& e )
	{
		sutilReportError( e.getErrorString().c_str() );
		getchar();
		exit(1);
	}
	return 0;
}
