#pragma once

#include <optixu/optixpp_namespace.h>
#include <optixu/optixu_math_namespace.h>
#include <iostream>
#include <GLUTDisplay.h>
#include <ImageLoader.h>
#include "commonStructs.h"
#include <cstdlib>
#include <cstring>
#include <sstream>
#include <math.h>

class Tutorial : public SampleScene
{
public:

	Tutorial::Tutorial(const std::string& texture_path)
		: SampleScene(), _width(1080u), _height(720u), texture_path( texture_path )
	{}

	virtual ~Tutorial();

	// From SampleScene
	void   initScene( InitialCameraData& camera_data );
	void   trace( const RayGenCameraData& camera_data );
	void   doResize( unsigned int width, unsigned int height );
	void   setDimensions( const unsigned int w, const unsigned int h ) { _width = w; _height = h; }
	optix::Buffer getOutputBuffer();

private:
	std::string texpath( const std::string& base );
	void createGeometry();

	unsigned int _width;
	unsigned int _height;
	std::string   texture_path;
	std::string  _ptx_path;
};
